/***************************************************************************
 $RCSfile: chipcard.h.in,v $
                             -------------------
    cvs         : $Id: chipcard.h.in,v 1.13 2003/02/17 04:17:46 aquamaniac Exp $
    begin       : Tue Aug 28 2001
    copyright   : (C) 2001 by Martin Preuss
    email       : martin@libchipcard.de

 ***************************************************************************
 *                                                                         *
 *   This library is free software; you can redistribute it and/or         *
 *   modify it under the terms of the GNU Lesser General Public            *
 *   License as published by the Free Software Foundation; either          *
 *   version 2.1 of the License, or (at your option) any later version.    *
 *                                                                         *
 *   This library is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU     *
 *   Lesser General Public License for more details.                       *
 *                                                                         *
 *   You should have received a copy of the GNU Lesser General Public      *
 *   License along with this library; if not, write to the Free Software   *
 *   Foundation, Inc., 59 Temple Place, Suite 330, Boston,                 *
 *   MA  02111-1307  USA                                                   *
 *                                                                         *
 ***************************************************************************/

/*
  Changes
 */

#ifndef CHIPCARD_H
#define CHIPCARD_H

/* setup DLL imports/exports for Windoze */
#ifdef __declspec
# if BUILDING_CHIPCARD_DLL
#  define CHIPCARD_API __declspec (dllexport)
# else /* Not BUILDING_CHIPCARD_DLL */
#  define CHIPCARD_API __declspec (dllimport)
# endif /* Not BUILDING_CHIPCARD_DLL */
#else
# define CHIPCARD_API
#endif


/* define if LibChipCard uses encryption */
#ifndef CT_USE_ENCRYPTION
#define CT_USE_ENCRYPTION
#endif

/* provide PC/SC stuff */
#ifndef WINSCARD_LIB
# define WINSCARD_LIB "libpcsclite.so.0"
#endif


/* openSSL includes */
#ifdef CT_USE_ENCRYPTION
/* FIXME: This is needed for GCC 3.2, because unistd.h and openssl/des.h have
 * different declarations concerning the exceptions to be thrown
 * without this you can not compile libchipcard on RedHat 8 systems.
 */
# define PERL5
# include <openssl/des.h>
# undef PERL5
#endif

/* define configuration files */
//#define CHIPCARDC_CFGFILE "/usr/local/etc/chipcardc.conf"
#define CHIPCARDC_CFGFILE "/usr/local/etc/chipcardc.conf"
#define CHIPCARDD_CFGFILE "/usr/local/etc/chipcardd.conf"
#define CHIPCARD_COMMANDS "/usr/local/share/libchipcard/commands"
#define CHIPCARD_DRIVERS "/usr/local/share/libchipcard/drivers"

#define CHIPCARDD_LOGDIR "/usr/local/var/log"
#define CHIPCARDD_LOGFILE "chipcardd.log"

/* include libchipcard stuff */
#include <ctversion.h>
#include <chipcard/libchipcard.h>
#include <chameleon/logger.h>
#ifdef __cplusplus
# include <chipcard/cterror.h>
# include <chipcard/ctpointer.h>
# include <chipcard/cttlv.h>
# include <chipcard/ctmisc.h>
# include <chipcard/ctcommand.h>

# include <chipcard/ctcard.h>
# include <chipcard/ctmemorycard.h>
# include <chipcard/ctprocessorcard.h>
# include <chipcard/ctkvkcard.h>
# include <chipcard/hbcicard.h>
# include <chipcard/rsacard.h>
# include <chipcard/ctgeldkarte.h>
#endif /* __cplusplus */

#endif /* CHIPCARD_H */


